<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_usuario_grupo.php");
require_once($config->diretorio_raiz()."/src/model/bd/Bi_usuarioDAO.php");
require_once($config->diretorio_raiz()."/src/model/bd/Bi_grupo_permissaoDAO.php");
class Bi_usuario_grupoDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_usuario_grupo)
	{
		$inputs = array();
		if($bi_usuario_grupo->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_usuario_grupo->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_usuario_grupo->getUsuario() != "")
		{
			array_push($inputs, array('campo'=>':usuario', 'valor'=>$bi_usuario_grupo->getUsuario()));
		}
		else
		{
			array_push($inputs, array('campo'=>':usuario', 'valor'=>null));
		}
		if($bi_usuario_grupo->getGrupo() != "")
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>$bi_usuario_grupo->getGrupo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_usuario_grupo (codigo, usuario, grupo) VALUES (:codigo, :usuario, :grupo)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_usuario_grupo($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_usuario_grupo where codigo = :codigo "; 
		$bi_usuario_grupo = new Bi_usuario_grupo();
		$rows_bi_usuario_grupo = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_usuario_grupo as $row)
		{
			$bi_usuario_grupo->setCodigo($row['codigo']);
			if($row['usuario'] != "")
			{
				$usuarioDAO = new Bi_usuarioDAO();
				$bi_usuario_grupo->setUsuario($usuarioDAO->buscarBi_usuario($row['usuario']));
			}
			else
			{
				$bi_usuario_grupo->setUsuario(new Bi_usuario());
			}
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_usuario_grupo->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
			}
		}
		return $bi_usuario_grupo;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_usuario_grupo  ".$where;
		$lista_bi_usuario_grupo = array();
		$rows_bi_usuario_grupo = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_usuario_grupo as $row)
		{
			$bi_usuario_grupo = new Bi_usuario_grupo();
			$bi_usuario_grupo->setCodigo($row['codigo']);
			if($row['usuario'] != "")
			{
				$usuarioDAO = new Bi_usuarioDAO();
				$bi_usuario_grupo->setUsuario($usuarioDAO->buscarBi_usuario($row['usuario']));
			}
			else
			{
				$bi_usuario_grupo->setUsuario(new Bi_usuario());
			}
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_usuario_grupo->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
			}
			array_push($lista_bi_usuario_grupo, $bi_usuario_grupo);
		}
		return $lista_bi_usuario_grupo;
	}
	public function atualizar($bi_usuario_grupo)
	{
		$inputs = array();
		if($bi_usuario_grupo->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_usuario_grupo->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_usuario_grupo->getUsuario() != "")
		{
			array_push($inputs, array('campo'=>':usuario', 'valor'=>$bi_usuario_grupo->getUsuario()));
		}
		else
		{
			array_push($inputs, array('campo'=>':usuario', 'valor'=>null));
		}
		if($bi_usuario_grupo->getGrupo() != "")
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>$bi_usuario_grupo->getGrupo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':grupo', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_usuario_grupo  SET codigo = :codigo, usuario = :usuario, grupo = :grupo WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_usuario_grupo)
	{
		try
		{
			$sql = "DELETE FROM bi_usuario_grupo  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_usuario_grupo->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_usuario_grupo";
		$listaBi_usuario_grupo = array();
		$rows_bi_usuario_grupo = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_usuario_grupo as $row)
		{
			$bi_usuario_grupo = new Bi_usuario_grupo();
			$bi_usuario_grupo->setCodigo($row['codigo']);
			if($row['usuario'] != "")
			{
				$usuarioDAO = new Bi_usuarioDAO();
				$bi_usuario_grupo->setUsuario($usuarioDAO->buscarBi_usuario($row['usuario']));
			}
			else
			{
				$bi_usuario_grupo->setUsuario(new Bi_usuario());
			}
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_usuario_grupo->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
			}
			array_push($listaBi_usuario_grupo,$bi_usuario_grupo );
		}
		return $listaBi_usuario_grupo;
	}
	public function buscarBi_usuario_grupoPorUsuario($usuario)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_usuario_grupo where usuario = ".$usuario."";
		$lista_bi_usuario_grupo = array();
		$rows_bi_usuario_grupo = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_usuario_grupo as $row)
		{
			$bi_usuario_grupo = new Bi_usuario_grupo();
			$bi_usuario_grupo->setCodigo($row['codigo']);
			if($row['usuario'] != "")
			{
				$usuarioDAO = new Bi_usuarioDAO();
				$bi_usuario_grupo->setUsuario($usuarioDAO->buscarBi_usuario($row['usuario']));
			}
			else
			{
				$bi_usuario_grupo->setUsuario(new Bi_usuario());
			}
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_usuario_grupo->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
			}
			array_push($lista_bi_usuario_grupo, $bi_usuario_grupo);
		}
		return $lista_bi_usuario_grupo;
	}
	public function buscarBi_usuario_grupoPorGrupo($grupo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_usuario_grupo where grupo = ".$grupo."";
		$lista_bi_usuario_grupo = array();
		$rows_bi_usuario_grupo = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_usuario_grupo as $row)
		{
			$bi_usuario_grupo = new Bi_usuario_grupo();
			$bi_usuario_grupo->setCodigo($row['codigo']);
			if($row['usuario'] != "")
			{
				$usuarioDAO = new Bi_usuarioDAO();
				$bi_usuario_grupo->setUsuario($usuarioDAO->buscarBi_usuario($row['usuario']));
			}
			else
			{
				$bi_usuario_grupo->setUsuario(new Bi_usuario());
			}
			if($row['grupo'] != "")
			{
				$grupoDAO = new Bi_grupo_permissaoDAO();
				$bi_usuario_grupo->setGrupo($grupoDAO->buscarBi_grupo_permissao($row['grupo']));
			}
			else
			{
				$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
			}
			array_push($lista_bi_usuario_grupo, $bi_usuario_grupo);
		}
		return $lista_bi_usuario_grupo;
	}
}